// Console.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include"string.h"
#include"stdlib.h"


typedef signed long  s32;
typedef signed short s16;
typedef signed char  s8;

typedef signed long  const sc32;  // Read Only 
typedef signed short const sc16;  // Read Only 
typedef signed char  const sc8;   // Read Only 

typedef volatile signed long  vs32;
typedef volatile signed short vs16;
typedef volatile signed char  vs8;

typedef volatile signed long  const vsc32;  // Read Only 
typedef volatile signed short const vsc16;  // Read Only 
typedef volatile signed char  const vsc8;   // Read Only 

typedef unsigned long  u32;
typedef unsigned short u16;
typedef unsigned char  u8;

typedef unsigned long  const uc32;  // Read Only 
typedef unsigned short const uc16;  // Read Only 
typedef unsigned char  const uc8;   // Read Only 

typedef volatile unsigned long  vu32;
typedef volatile unsigned short vu16;
typedef volatile unsigned char  vu8;

typedef volatile unsigned long  const vuc32;  // Read Only 
typedef volatile unsigned short const vuc16;  // Read Only 
typedef volatile unsigned char  const vuc8;   // Read Only 


HANDLE hCom;//串口句柄

unsigned char OpenAndSetPort(char *com)
{
	hCom=CreateFile(com,//COM1口
		  GENERIC_READ|GENERIC_WRITE, //允许读和写
		  0, //独占方式
		  NULL,
		  OPEN_EXISTING, //打开而不是创建
		  0, //同步方式
		  NULL);
	if(hCom==(HANDLE)-1)
	{
		return 0;//Open Error!
	}
	
	SetupComm(hCom,1024,1024);

	DCB dcb;
	FillMemory(&dcb, sizeof(dcb), 0);
	dcb.DCBlength = sizeof(dcb);
	BuildCommDCB("9600,n,8,1", &dcb);


	if (!SetCommState(hCom, &dcb))
	{
		return 0;//Setting Error!!!!
	}

	//设置读写超时时间
	COMMTIMEOUTS to;
	memset(&to, 0, sizeof(to));
	to.ReadIntervalTimeout = 100;
	to.ReadTotalTimeoutMultiplier=10;
	to.ReadTotalTimeoutConstant =10;
	SetCommTimeouts(hCom, &to);
	PurgeComm(hCom, PURGE_TXCLEAR | PURGE_RXCLEAR);
	return 1;
}


u16 usMBCRC16(u8 *src, int srclen)
{
	u8 aucCRCHi[] = {
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
			0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
			0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
			0x00, 0xC1, 0x81, 0x40
	};
	
	u8 aucCRCLo[] = {
			0x00, 0xC0, 0xC1, 0x01, 0xC3, 0x03, 0x02, 0xC2, 0xC6, 0x06, 0x07, 0xC7,
			0x05, 0xC5, 0xC4, 0x04, 0xCC, 0x0C, 0x0D, 0xCD, 0x0F, 0xCF, 0xCE, 0x0E,
			0x0A, 0xCA, 0xCB, 0x0B, 0xC9, 0x09, 0x08, 0xC8, 0xD8, 0x18, 0x19, 0xD9,
			0x1B, 0xDB, 0xDA, 0x1A, 0x1E, 0xDE, 0xDF, 0x1F, 0xDD, 0x1D, 0x1C, 0xDC,
			0x14, 0xD4, 0xD5, 0x15, 0xD7, 0x17, 0x16, 0xD6, 0xD2, 0x12, 0x13, 0xD3,
			0x11, 0xD1, 0xD0, 0x10, 0xF0, 0x30, 0x31, 0xF1, 0x33, 0xF3, 0xF2, 0x32,
			0x36, 0xF6, 0xF7, 0x37, 0xF5, 0x35, 0x34, 0xF4, 0x3C, 0xFC, 0xFD, 0x3D,
			0xFF, 0x3F, 0x3E, 0xFE, 0xFA, 0x3A, 0x3B, 0xFB, 0x39, 0xF9, 0xF8, 0x38,
			0x28, 0xE8, 0xE9, 0x29, 0xEB, 0x2B, 0x2A, 0xEA, 0xEE, 0x2E, 0x2F, 0xEF,
			0x2D, 0xED, 0xEC, 0x2C, 0xE4, 0x24, 0x25, 0xE5, 0x27, 0xE7, 0xE6, 0x26,
			0x22, 0xE2, 0xE3, 0x23, 0xE1, 0x21, 0x20, 0xE0, 0xA0, 0x60, 0x61, 0xA1,
			0x63, 0xA3, 0xA2, 0x62, 0x66, 0xA6, 0xA7, 0x67, 0xA5, 0x65, 0x64, 0xA4,
			0x6C, 0xAC, 0xAD, 0x6D, 0xAF, 0x6F, 0x6E, 0xAE, 0xAA, 0x6A, 0x6B, 0xAB,
			0x69, 0xA9, 0xA8, 0x68, 0x78, 0xB8, 0xB9, 0x79, 0xBB, 0x7B, 0x7A, 0xBA,
			0xBE, 0x7E, 0x7F, 0xBF, 0x7D, 0xBD, 0xBC, 0x7C, 0xB4, 0x74, 0x75, 0xB5,
			0x77, 0xB7, 0xB6, 0x76, 0x72, 0xB2, 0xB3, 0x73, 0xB1, 0x71, 0x70, 0xB0,
			0x50, 0x90, 0x91, 0x51, 0x93, 0x53, 0x52, 0x92, 0x96, 0x56, 0x57, 0x97,
			0x55, 0x95, 0x94, 0x54, 0x9C, 0x5C, 0x5D, 0x9D, 0x5F, 0x9F, 0x9E, 0x5E,
			0x5A, 0x9A, 0x9B, 0x5B, 0x99, 0x59, 0x58, 0x98, 0x88, 0x48, 0x49, 0x89,
			0x4B, 0x8B, 0x8A, 0x4A, 0x4E, 0x8E, 0x8F, 0x4F, 0x8D, 0x4D, 0x4C, 0x8C,
			0x44, 0x84, 0x85, 0x45, 0x87, 0x47, 0x46, 0x86, 0x82, 0x42, 0x43, 0x83,
			0x41, 0x81, 0x80, 0x40
	};

	u8           ucCRCHi = 0xFF;
    u8           ucCRCLo = 0xFF;
    u8             iIndex;
	
    while ( srclen-- )
    {
        iIndex = ucCRCLo ^ *(src++);
        ucCRCLo =  ucCRCHi ^ aucCRCHi[iIndex];
        ucCRCHi = aucCRCLo[iIndex];
    }
    return(u16)(ucCRCHi << 8 | ucCRCLo);
}



unsigned char SendAndRead(u8 *src,int srclen)
{
	unsigned char n;
	unsigned long Bytes=0;
	PurgeComm(hCom, PURGE_TXCLEAR | PURGE_RXCLEAR);
	WriteFile(hCom,src,srclen,&Bytes,NULL);//把9字节发送出去.

	printf("\r\nSending %d bytes...\r\n",Bytes);
	for(n=0;n<Bytes;n++)
	{
		printf("%0.2XH ",src[n]);
	}

	u8 rcvbuff[100];
	int rcvbuff_len = 100;
	
	ReadFile(hCom,rcvbuff,rcvbuff_len,&Bytes,NULL);//读返回的数据.读超时根据COMMTIMEOUTS to;变量设定

	if(Bytes>0)
	{
		printf("\r\nReceived %d bytes...\r\n",Bytes);
		for(n=0;n<Bytes;n++)
		{
			printf("%0.2XH ",rcvbuff[n]);
		}
		if(usMBCRC16(rcvbuff,Bytes)==0x00)
		{
			printf("\r\n终端响应成功\r\n");
		}
		else
		    printf("\r\n终端响应校验失败\r\n");
	}
	else 
		printf("\r\n终端无响应\r\n");
	/*
	if(Bytes==BUFF_SIZE)
	{
		printf("\r\nReceived %d bytes...\r\n",Bytes);
		for(n=0;n<Bytes;n++)
		{
			printf("%0.2XH ",SendBuff[n]);
		}
		if(CheckSum(SendBuff)==0)
		{
			printf("Check Sum Error!");
			return 0;//Check sum Error!!!
		}
		//RelayStatus(SendBuff[6]);
	}
	else 
	{
		printf("\r\nConnection failed!Please check the power supply and RS232 Bus line\r\n");
		return 0;//Error!!!
	}*/


	return 1;
}

int OpenDO(int addr,int io,u8 *src)
{
	int index = 0;
	src[index++] = addr;
	src[index++] = 0x05;
	src[index++] = 0x00;
	src[index++] = io-1;
	src[index++] = 0xff;
	src[index++] = 0x00;

	u16 crc = usMBCRC16(src,index);
	src[index++]  = crc&0xff;
	src[index++]  = crc>>8;
	return index;
}
int CloseDO(int addr,int io,u8 *src)
{
	int index = 0;
	src[index++] = addr;
	src[index++] = 0x05;
	src[index++] = 0x00;
	src[index++] = io-1;
	src[index++] = 0x00;
	src[index++] = 0x00;

	u16 crc = usMBCRC16(src,index);
	src[index++]  = crc&0xff;
	src[index++]  = crc>>8;
	return index;
}
int ReadDO(int addr,int ionum,u8 *src)
{
	int index = 0;
	src[index++] = addr;
	src[index++] = 0x01;
	src[index++] = 0x00;
	src[index++] = 0x00;
	src[index++] = 0x00;
	src[index++] = ionum;

	u16 crc = usMBCRC16(src,index);
	src[index++]  = crc&0xff;
	src[index++]  = crc>>8;
	return index;
}
int WDO(int addr,int info1,int info2,int info3,int info4,u8 *src)
{
	int index = 0;
	src[index++] = addr;
	src[index++] = 0x0f;
	src[index++] = 0x00;
	src[index++] = 0x00;
	src[index++] = 0x00;
	src[index++] = 32;
	src[index++] = 4;
	src[index++] = info1;
	src[index++] = info2;
	src[index++] = info3;
	src[index++] = info4;

	u16 crc = usMBCRC16(src,index);
	src[index++]  = crc&0xff;
	src[index++]  = crc>>8;
	return index;
}
//com1 addr on   1
//com1 addr off  1
//com1 addr wdo  00 00 00 00
//com1 addr rdo
  
int main(int argc, char* argv[])
{
	if(argc<4)
	{
		printf("参数有误!\r\n");
		return 0;
	}

	if(OpenAndSetPort(argv[1])==0)
	{
		printf("\r\n打开串口%s错误\r\n",argv[1]);
		return 0;
	}
	else
	{
		printf("\r\n%s已打开\t波特率:9600\r\n",argv[1]);
	}
	
	int addr = atoi(argv[2]);
	char *command = argv[3];

	u8 src[200];
	int srclen = 0;
	
	if(strcmpi(command,"on")==0)
	{
		srclen = OpenDO(addr,atoi(argv[4]),src);
	}
	else if(strcmpi(command,"off")==0)
	{
		srclen = CloseDO(addr,atoi(argv[4]),src);
	}
	else if(strcmpi(command,"rdo")==0)
	{
		srclen = ReadDO(addr,32,src);
	}
	else if(strcmpi(command,"wdo")==0)
	{
		srclen = WDO(addr,atoi(argv[4]),atoi(argv[5]),atoi(argv[6]),atoi(argv[7]),src);
	}
	else 
	{
		printf("命令有误!");
		return 1;
	}
	SendAndRead(src,srclen);
	
	return 1;
}

